## edb-debugger 1.2.0

=== debian/changelog ===
edb-debugger (1.2.0-2) unstable; urgency=medium

  * debian/control:
      - Updated the Vcs-Git and Vcs-Browser.

 -- Marcio de Souza Oliveira <marciosouza@debian.org>  Wed, 06 May 2020 13:01:37 +0000

edb-debugger (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Bumped DH level to 12.
  * debian/control:
      - Bumped Standards-Version to 4.5.0.
      - Updated the maintainer email.
  * debian/patches:
      - Created the patch fix_cmakelists.txt.patch.
      - Renamed the patch fix_desktop_entry.
      - Removed the patches: fix_makefile and fix_default_plugin_path.
      - Updated the patch fix_spelling.patch.
  * debian/rules:
      - Updated the file.
  * debian/salsa-ci.yml:
      - Updated to allow failure in blhc test.
      - Updated to allow failure in reprotest.
  * debian/tests/control:
      - Created to perform a trivial test.
  * Updated the file edb-debugger.install.

 -- Marcio de Souza Oliveira <marciosouza@debian.org>  Sat, 04 Apr 2020 21:19:24 +0000

=== debian/control ===
Source: edb-debugger
Section: devel
Priority: optional
Maintainer: Marcio de Souza Oliveira <marciosouza@debian.org>
Build-Depends: debhelper (>= 12),
 cmake,
 libboost-dev,
 libcapstone-dev,
 libgraphviz-dev,
 libqt5svg5-dev,
 libqt5xmlpatterns5-dev,
 pkg-config,
 qt5-qmake,
 qtbase5-dev
Standards-Version: 4.5.0
Homepage: https://github.com/eteran/edb-debugger
Vcs-Git: https://salsa.debian.org/debian/edb-debugger.git
Vcs-Browser: https://salsa.debian.org/debian/edb-debugger.git

Package: edb-debugger
Architecture: i386 amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, edb-debugger-plugins
Description: cross platform x86/x86-64 debugger
 edb is a graphical cross platform x86/x86-64 debugger.
 It was inspired by Ollydbg, but aims to function on x86
 and x86-64 as well as multiple OS's. Linux is the only
 officially supported platform at the moment, but FreeBSD,
 OpenBSD, OSX and Windows ports are underway with varying
 degrees of functionality.

Package: edb-debugger-plugins
Section: libs
Architecture: i386 amd64
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: edb plugins
 edb is a graphical cross platform x86/x86-64 debugger.
 It was inspired by Ollydbg, but aims to function on x86
 and x86-64 as well as multiple OS's. Linux is the only
 officially supported platform at the moment, but FreeBSD,
 OpenBSD, OSX and Windows ports are underway with varying
 degrees of functionality.
 .
 This package provides the plugins that used by edb.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,relro

%:
	dh $@

=== debian/tests/control ===
Test-Command: xvfb-run edb --version
Depends: @, xauth, xvfb

## edb-debugger 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project (edb CXX)

enable_testing()

if(NOT EXISTS "${PROJECT_SOURCE_DIR}/src/qhexview/.git")
	message(SEND_ERROR "The git submodules are not available. Please run:\ngit submodule update --init --recursive")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/Modules/")

include("GNUInstallDirs")
include("CheckIncludeFileCXX")
include("DetectCompiler")
include("DetectOS")
include("DetectArchitecture")
include("EnableSanitizers")
include("EnableSTLDebug")
include("ProjectDefaults")

if(TARGET_COMPILER_GCC AND ${CMAKE_CXX_COMPILER_VERSION} VERSION_LESS 5.0)
	message(FATAL_ERROR "Your g++ version is too old. At least 5.0 is required.")
endif()

find_package(Boost 1.35 REQUIRED)
include_directories(${Boost_INCLUDE_DIR})

find_package(Capstone REQUIRED)
include_directories(${CAPSTONE_INCLUDE_DIRS})
link_directories(${CAPSTONE_LIBRARY_DIRS})

# eventually use this to generate version.h?
set(TARGET_VERSION_MAJOR 1)
set(TARGET_VERSION_MINOR 3)
set(TARGET_VERSION_PATCH 0)
set_property(GLOBAL PROPERTY VERSION ${TARGET_VERSION_MAJOR}.${TARGET_VERSION_MINOR}.${TARGET_VERSION_PATCH})

if (UNIX)
	find_package(PkgConfig REQUIRED)
	pkg_check_modules(GRAPHVIZ libgvc>=2.38.0)
	if(GRAPHVIZ_FOUND)
		include_directories(${GRAPHVIZ_INCLUDE_DIRS})
		link_directories(${GRAPHVIZ_LIBRARY_DIRS})
		add_definitions(-DENABLE_GRAPH)
	endif()
endif()

message(STATUS "Checking for module 'double-conversion'")
# Using check_include_file_cxx instead of find_package etc. to support various versions of double-conversion. Some versions don't have CMake modules, some have a bit incompatible ones...
check_include_file_cxx("double-conversion/double-conversion.h" HAVE_DOUBLE_CONVERSION)
if(NOT HAVE_DOUBLE_CONVERSION)
   UNSET(HAVE_DOUBLE_CONVERSION CACHE)
   message(WARNING "libdouble-conversion header wasn't found. 32- and 64-bit floating-point values will be shown with max_digits10 digits of precision instead of shortest representation.")
else()
   find_library(DOUBLE_CONVERSION_LIBRARIES double-conversion)
   if(NOT DOUBLE_CONVERSION_LIBRARIES)
	   message(WARNING "libdouble-conversion library wasn't found. 32- and 64-bit floating-point values will be shown with max_digits10 digits of precision instead of shortest representation.")
   else()
       add_definitions("-DHAVE_DOUBLE_CONVERSION")
   endif()
endif()

find_package(Qt5Core)

include_directories("include")

if(TARGET_PLATFORM_LINUX)
	include_directories("include/os/unix")
	include_directories("include/os/unix/linux")
elseif(TARGET_PLATFORM_WINDOWS)
	include_directories("include/os/win32")
endif()

if(TARGET_ARCH_X86 OR TARGET_ARCH_ARM32)
	add_definitions(-DEDB_IS_32_BIT=true -DEDB_IS_64_BIT=false)
elseif(TARGET_ARCH_X64 OR TARGET_ARCH_ARM64)
	add_definitions(-DEDB_IS_32_BIT=false -DEDB_IS_64_BIT=true)
else()
	message(SEND_ERROR "Unexpected bitness: \"sizeof(void*)=${CMAKE_SIZEOF_VOID_P}.\"")
endif()

if(TARGET_ARCH_X86)
	add_definitions(-DEDB_X86)
	include_directories("include/arch/x86-generic")
elseif(TARGET_ARCH_X64)
	add_definitions(-DEDB_X86_64)
	include_directories("include/arch/x86-generic")
elseif(TARGET_ARCH_ARM32)
	add_definitions(-DEDB_ARM32)
	include_directories("include/arch/arm-generic")
elseif(TARGET_ARCH_ARM64)
	add_definitions(-DEDB_ARM64)
	include_directories("include/arch/arm-generic")
endif()

# FIXME: This is also useful on Windows, so it should be made usable there too.
if(UNIX)
	if(TARGET_ARCH_FAMILY_X86)
		pkg_check_modules(GDTOA gdtoa-desktop)
		if(NOT GDTOA_FOUND)
			message(WARNING "gdtoa-desktop package wasn't found. 80-bit floating-point values will be shown with max_digits10 digits of precision instead of shortest representation.")
		else()
			add_definitions("-DHAVE_GDTOA")
			include_directories(${GDTOA_INCLUDE_DIRS})
			link_directories(${GDTOA_LIBRARY_DIRS})
		endif()
	endif()
endif()


if (TARGET_COMPILER_CLANG OR TARGET_COMPILER_GCC)
    add_compile_options(
		-W
		-Wall
		#-Wshadow
		-Wnon-virtual-dtor
		#-Wold-style-cast
		-Wcast-align
		-Wunused
		-Woverloaded-virtual
		-pedantic
		#-Wconversion
		#-Wsign-conversion
		#-Wnull-dereference
		-Wdouble-promotion
		-Wformat=2
		-Wno-unused-macros
		-Wno-switch-enum
		-Wno-unknown-pragmas
    )

    if(TARGET_COMPILER_CLANG)
		add_compile_options(
			#-Wshorten-64-to-32
			-Wconditional-uninitialized
			#-Wshadow-uncaptured-local
			-Wmissing-prototypes
			#-Wexit-time-destructors
			#-Wglobal-constructors
			-Wimplicit-fallthrough
		)

    elseif(TARGET_COMPILER_GCC)
		add_compile_options(
			#-Wuseless-cast
			#-Wduplicated-cond
			#-Wduplicated-branches
			-Wlogical-op

			#-Wsuggest-attribute=pure
			#-Wsuggest-attribute=const
			#-Wsuggest-attribute=noreturn
			#-Wsuggest-final-types
			#-Wsuggest-final-methods
			-Wsuggest-override
		)
	endif()
endif()

add_subdirectory(src)
add_subdirectory(plugins)
add_subdirectory(libELF)
add_subdirectory(libPE)

install (FILES ${CMAKE_SOURCE_DIR}/edb.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install (FILES ${CMAKE_SOURCE_DIR}/edb.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications/)
install (FILES ${CMAKE_SOURCE_DIR}/src/images/edb.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/pixmaps/)

=== libELF/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

add_library(ELF INTERFACE
)

target_include_directories(ELF
	INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include
)

target_sources(ELF INTERFACE
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_model.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_auxv.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_binary.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_dyn.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_header.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_move.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_nhdr.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_phdr.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_rela.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_rel.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_shdr.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_sym.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_syminfo.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_types.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_verdaux.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_verdef.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_vernaux.h
	${CMAKE_CURRENT_SOURCE_DIR}/include/libELF/elf_verneed.h
)

=== libPE/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

add_library(PE INTERFACE
)

target_include_directories(PE
	INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/include
)

target_sources(PE INTERFACE
	${CMAKE_CURRENT_SOURCE_DIR}/include/libPE/pe_binary.h

)

=== plugins/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)

add_definitions(-DQT_PLUGIN)

add_subdirectory(DebuggerCore)
add_subdirectory(Analyzer)
add_subdirectory(Assembler)
add_subdirectory(BinaryInfo)
add_subdirectory(Bookmarks)
add_subdirectory(BreakpointManager)
add_subdirectory(CheckVersion)
add_subdirectory(OpcodeSearcher)
add_subdirectory(ProcessProperties)
add_subdirectory(ROPTool)
add_subdirectory(References)
add_subdirectory(SymbolViewer)
add_subdirectory(Backtrace)
add_subdirectory(DumpState)
add_subdirectory(FunctionFinder)
add_subdirectory(DebuggerErrorConsole)
add_subdirectory(BinarySearcher)
add_subdirectory(InstructionInspector)
add_subdirectory(FasLoader)
add_subdirectory(ODbgRegisterView)

if(TARGET_ARCH_FAMILY_X86)
    add_subdirectory(HardwareBreakpoints)
endif()

if(TARGET_PLATFORM_LINUX)
    add_subdirectory(HeapAnalyzer)
endif()

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")
include("DetectGitBranch")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

find_package(Qt5 5.0.0 REQUIRED Widgets Xml XmlPatterns Svg)

git_get_branch(GIT_BRANCH)

qt5_add_resources(QRC_SOURCES
	debugger.qrc
	themes.qrc
	breeze-edb.qrc
	breeze-dark-edb.qrc
)

foreach(FILE IN LISTS QRC_SOURCES)
	set_property(SOURCE ${FILE} PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)
endforeach()

set(edb_SRCS
	${QRC_SOURCES}

	BasicBlock.cpp
	BinaryString.cpp
	BinaryString.ui
	ByteShiftArray.cpp
	CommentServer.cpp
	CommentServer.h
	Configuration.cpp
	DataViewInfo.cpp
	DataViewInfo.h
	DebugEventHandlers.cpp
	DebugEventHandlers.h
	Debugger.cpp
	Debugger.h
	Debugger.ui
	DebuggerInternal.h
	DialogAbout.cpp
	DialogAbout.h
	DialogAbout.ui
	DialogArguments.cpp
	DialogArguments.h
	DialogArguments.ui
	DialogAttach.cpp
	DialogAttach.h
	DialogAttach.ui
	DialogInputBinaryString.cpp
	DialogInputBinaryString.h
	DialogInputBinaryString.ui
	DialogInputValue.cpp
	DialogInputValue.h
	DialogInputValue.ui
	DialogMemoryRegions.cpp
	DialogMemoryRegions.h
	DialogMemoryRegions.ui
	DialogOpenProgram.cpp
	DialogOpenProgram.h
	DialogOptions.cpp
	DialogOptions.h
	DialogOptions.ui
	DialogPlugins.cpp
	DialogPlugins.h
	DialogPlugins.ui
	DialogThreads.cpp
	DialogThreads.h
	DialogThreads.ui
	ExpressionDialog.cpp
	ExpressionDialog.h
	FixedFontSelector.cpp
	FixedFontSelector.h
	FixedFontSelector.ui
	FloatX.cpp
	Font.cpp
	Function.cpp
	HexStringValidator.cpp
	MemoryRegions.cpp
	PluginModel.cpp
	PluginModel.h
	ProcessModel.cpp
	ProcessModel.h
	QLongValidator.cpp
	QULongValidator.cpp
	RecentFileManager.cpp
	RecentFileManager.h
	RegionBuffer.cpp
	RegionBuffer.h
	Register.cpp
	RegisterViewModelBase.cpp
	State.cpp
	SymbolManager.cpp
	SymbolManager.h
	Theme.cpp
	ThreadsModel.cpp
	capstone-edb/Inspection.cpp
	capstone-edb/Instruction.cpp
	capstone-edb/include/Formatter.h
	capstone-edb/include/Inspection.h
	capstone-edb/include/Instruction.h
	capstone-edb/include/Operand.h
	edb.cpp
	main.cpp
	qhexview/QHexView
	qhexview/qhexview.cpp
	qhexview/qhexview.h
	session/SessionError.cpp
	session/SessionError.h
	session/SessionManager.cpp
	session/SessionManager.h
	widgets/NavigationHistory.cpp
	widgets/NavigationHistory.h
	widgets/QDisassemblyView.cpp
	widgets/QDisassemblyView.h
	widgets/RegisterViewDelegate.cpp
	widgets/RegisterViewDelegate.h
	widgets/SyntaxHighlighter.cpp
	widgets/SyntaxHighlighter.h
	widgets/TabWidget.cpp
	widgets/TabWidget.h

	${PROJECT_SOURCE_DIR}/include/API.h
	${PROJECT_SOURCE_DIR}/include/ArchProcessor.h
	${PROJECT_SOURCE_DIR}/include/BasicBlock.h
	${PROJECT_SOURCE_DIR}/include/BinaryString.h
	${PROJECT_SOURCE_DIR}/include/ByteShiftArray.h
	${PROJECT_SOURCE_DIR}/include/Configuration.h
	${PROJECT_SOURCE_DIR}/include/Expression.h
	${PROJECT_SOURCE_DIR}/include/FloatX.h
	${PROJECT_SOURCE_DIR}/include/Function.h
	${PROJECT_SOURCE_DIR}/include/HexStringValidator.h
	${PROJECT_SOURCE_DIR}/include/IAnalyzer.h
	${PROJECT_SOURCE_DIR}/include/IBinary.h
	${PROJECT_SOURCE_DIR}/include/IBreakpoint.h
	${PROJECT_SOURCE_DIR}/include/IDebugEvent.h
	${PROJECT_SOURCE_DIR}/include/IDebugEventHandler.h
	${PROJECT_SOURCE_DIR}/include/IDebugger.h
	${PROJECT_SOURCE_DIR}/include/IPlugin.h
	${PROJECT_SOURCE_DIR}/include/IProcess.h
	${PROJECT_SOURCE_DIR}/include/IRegion.h
	${PROJECT_SOURCE_DIR}/include/IState.h
	${PROJECT_SOURCE_DIR}/include/ISymbolGenerator.h
	${PROJECT_SOURCE_DIR}/include/ISymbolManager.h
	${PROJECT_SOURCE_DIR}/include/IThread.h
	${PROJECT_SOURCE_DIR}/include/Instruction.h
	${PROJECT_SOURCE_DIR}/include/MemoryRegions.h
	${PROJECT_SOURCE_DIR}/include/Module.h
	${PROJECT_SOURCE_DIR}/include/Patch.h
	${PROJECT_SOURCE_DIR}/include/Prototype.h
	${PROJECT_SOURCE_DIR}/include/QLongValidator.h
	${PROJECT_SOURCE_DIR}/include/QULongValidator.h
	${PROJECT_SOURCE_DIR}/include/QtHelper.h
	${PROJECT_SOURCE_DIR}/include/Register.h
	${PROJECT_SOURCE_DIR}/include/RegisterRef.h
	${PROJECT_SOURCE_DIR}/include/RegisterViewModelBase.h
	${PROJECT_SOURCE_DIR}/include/State.h
	${PROJECT_SOURCE_DIR}/include/Status.h
	${PROJECT_SOURCE_DIR}/include/Symbol.h
	${PROJECT_SOURCE_DIR}/include/Theme.h
	${PROJECT_SOURCE_DIR}/include/ThreadsModel.h
	${PROJECT_SOURCE_DIR}/include/Types.h
	${PROJECT_SOURCE_DIR}/include/Util.h
	${PROJECT_SOURCE_DIR}/include/Value.h
	${PROJECT_SOURCE_DIR}/include/edb.h
	${PROJECT_SOURCE_DIR}/include/string_hash.h
	${PROJECT_SOURCE_DIR}/include/util/Container.h
	${PROJECT_SOURCE_DIR}/include/util/Float.h
	${PROJECT_SOURCE_DIR}/include/util/Font.h
	${PROJECT_SOURCE_DIR}/include/util/Integer.h
	${PROJECT_SOURCE_DIR}/include/util/Math.h
	${PROJECT_SOURCE_DIR}/include/util/String.h
	${PROJECT_SOURCE_DIR}/include/util/Error.h
	${PROJECT_SOURCE_DIR}/include/version.h
)

if(TARGET_ARCH_FAMILY_X86)
	set(edb_SRCS
		${edb_SRCS}
		arch/x86-generic/ArchProcessor.cpp
		arch/x86-generic/RegisterViewModel.cpp
		arch/x86-generic/RegisterViewModel.h
		${PROJECT_SOURCE_DIR}/include/arch/x86-generic/ArchTypes.h
	)
elseif(TARGET_ARCH_FAMILY_ARM)
	set(edb_SRCS
		${edb_SRCS}
		arch/arm-generic/ArchProcessor.cpp
		arch/arm-generic/RegisterViewModel.cpp
		arch/arm-generic/RegisterViewModel.h
		${PROJECT_SOURCE_DIR}/include/arch/arm-generic/ArchTypes.h
	)
endif()

if(TARGET_PLATFORM_WINDOWS)
	enable_language(ASM_MASM)
	set(CMAKE_ASM_MASM_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /safeseh")

	set(edb_SRCS
		${edb_SRCS}
		LongDoubleX86.asm
		${PROJECT_SOURCE_DIR}/include/os/win32/OSTypes.h
	)
elseif(TARGET_PLATFORM_LINUX)
    set(edb_SRCS
        ${edb_SRCS}
		${PROJECT_SOURCE_DIR}/include/os/unix/OSTypes.h
        ${PROJECT_SOURCE_DIR}/include/os/unix/linux/linker.h
    )
endif()

if(GRAPHVIZ_FOUND)
	set(edb_SRCS
		${edb_SRCS}
		graph/GraphEdge.cpp
		graph/GraphicsScene.cpp
		graph/GraphicsScene.h
		graph/GraphNode.cpp
		graph/GraphWidget.cpp
		graph/GraphvizHelper.cpp
		graph/GraphvizHelper.h
		${PROJECT_SOURCE_DIR}/include/GraphWidget.h
		${PROJECT_SOURCE_DIR}/include/GraphEdge.h
		${PROJECT_SOURCE_DIR}/include/GraphNode.h
	)
endif()

add_executable(edb ${edb_SRCS})

target_compile_definitions(edb PRIVATE
	-DGIT_BRANCH=${GIT_BRANCH}
	-DDEFAULT_PLUGIN_PATH=\"${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/edb\"
)

target_link_libraries(edb
	${CAPSTONE_LIBRARIES}
	Qt5::Widgets
	Qt5::Xml
	Qt5::XmlPatterns
	Qt5::Svg
	${GRAPHVIZ_LIBRARIES}
	${DOUBLE_CONVERSION_LIBRARIES}
	${GDTOA_LIBRARIES}
)

target_include_directories (edb PRIVATE
	"capstone-edb"
	"qhexview"
	"widgets"
	"session"
)

install (TARGETS edb DESTINATION ${CMAKE_INSTALL_BINDIR})

set_property(TARGET edb PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET edb PROPERTY CXX_STANDARD 14)
set_property(TARGET edb PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET edb PROPERTY ENABLE_EXPORTS TRUE)
set_property(TARGET edb PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

add_subdirectory("${CMAKE_CURRENT_LIST_DIR}/test")

=== plugins/Analyzer/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "Analyzer")

find_package(Qt5 5.0.0 REQUIRED Widgets)

add_library(${PluginName} SHARED
	Analyzer.cpp
	Analyzer.h
	AnalyzerWidget.cpp
	AnalyzerWidget.h
	DialogXRefs.cpp
	DialogXRefs.h
	DialogXRefs.ui
	OptionsPage.cpp
	OptionsPage.h
	OptionsPage.ui
	SpecifiedFunctions.cpp
	SpecifiedFunctions.h
	SpecifiedFunctions.ui
)

target_link_libraries(${PluginName} Qt5::Widgets edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== plugins/Assembler/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "Assembler")

find_package(Qt5 5.0.0 REQUIRED Widgets Xml XmlPatterns)

qt5_add_resources(QRC_SOURCES 
	Assembler.qrc
)

foreach(FILE IN LISTS QRC_SOURCES)
	set_property(SOURCE ${FILE} PROPERTY SKIP_UNITY_BUILD_INCLUSION ON)
endforeach()

add_library(${PluginName} SHARED
	${QRC_SOURCES}
	Assembler.cpp
	Assembler.h
	DialogAssembler.cpp
	DialogAssembler.h
	DialogAssembler.ui
	OptionsPage.cpp
	OptionsPage.h
	OptionsPage.ui
)

target_link_libraries(${PluginName} Qt5::Widgets Qt5::Xml Qt5::XmlPatterns edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== plugins/Backtrace/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "Backtrace")

find_package(Qt5 5.0.0 REQUIRED Widgets)

add_library(${PluginName} SHARED
	Backtrace.cpp
	Backtrace.h
	CallStack.cpp
	CallStack.h
	DialogBacktrace.cpp
	DialogBacktrace.h
	DialogBacktrace.ui
)

target_link_libraries(${PluginName} Qt5::Widgets edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== plugins/BinaryInfo/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "BinaryInfo")

find_package(Qt5 5.0.0 REQUIRED Widgets)

add_library(${PluginName} SHARED
	BinaryInfo.cpp
	BinaryInfo.h
	demangle.h
	DialogRegions.cpp
	DialogRegions.h
	DialogRegions.ui
	DialogHeader.ui
	DialogHeader.cpp
	DialogHeader.h
	ELF32.cpp
	ELF64.cpp
	ELFXX.cpp
	ELFXX.h
	OptionsPage.cpp
	OptionsPage.h
	OptionsPage.ui
	PE32.cpp
	PE32.h
	symbols.cpp
	symbols.h
)

target_link_libraries(${PluginName} Qt5::Widgets PE ELF edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== plugins/BinarySearcher/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "BinarySearcher")

find_package(Qt5 5.0.0 REQUIRED Widgets)

add_library(${PluginName} SHARED
	BinarySearcher.cpp
	BinarySearcher.h
	DialogAsciiString.cpp
	DialogAsciiString.h
	DialogAsciiString.ui
	DialogBinaryString.cpp
	DialogBinaryString.h
	DialogBinaryString.ui
	DialogResults.cpp
	DialogResults.h
	DialogResults.ui
)

target_link_libraries(${PluginName} Qt5::Widgets edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== plugins/Bookmarks/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "Bookmarks")

find_package(Qt5 5.0.0 REQUIRED Widgets)

add_library(${PluginName} SHARED
	Bookmarks.cpp
	Bookmarks.h
	BookmarkWidget.cpp
	BookmarkWidget.h
	BookmarksModel.cpp
	BookmarksModel.h
	BookmarkWidget.ui
)

target_link_libraries(${PluginName} Qt5::Widgets edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== plugins/BreakpointManager/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
include("GNUInstallDirs")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)

set(PluginName "BreakpointManager")

find_package(Qt5 5.0.0 REQUIRED Widgets)

add_library(${PluginName} SHARED
	BreakpointManager.cpp
	BreakpointManager.h
	DialogBreakpoints.cpp
	DialogBreakpoints.h
	DialogBreakpoints.ui
)

target_link_libraries(${PluginName} Qt5::Widgets edb)

install (TARGETS ${PluginName} DESTINATION ${CMAKE_INSTALL_LIBDIR}/edb)

set_property(TARGET ${PluginName} PROPERTY CXX_EXTENSIONS OFF)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD 14)
set_property(TARGET ${PluginName} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${PluginName} PROPERTY LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_property(TARGET ${PluginName} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

=== debian/changelog ===
edb-debugger (1.3.0-1) unstable; urgency=medium

  [ Marcio de Souza Oliveira ]
  * New upstream version 1.3.0.
  * debian/control:
      - Added the flag Rules-Require-Root.
      - Bumped Standards-Version to 4.5.1.
  * debian/patches:
      - Disabled the patches:
        0004-widgets-QDisassemblyView-include-QPainterPath.patch.
  * debian/rules: comment the DH_VERBOSE.
  * Ran wrap-and-sort.
  * Updated the edb-debugger.install.
  * Using new DH level format. Consequently:
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 13.

  [ Sophie Brun ]
  * d/watch: download special upstream tarball including qhexview files
  * New upstream version 1.3.0
  * Separate GPL2 and GPL2+ in debian/copyright to remove lintian warnings
  * Fix Vcs-Browser field in debian/control
  * Add a Build-dep libdouble-conversion-dev
  * Make autopkgtest superficial (Closes: #974452)

 -- Marcio de Souza Oliveira <marciosouza@debian.org>  Tue, 26 Jan 2021 15:01:19 +0100

edb-debugger (1.2.0-2.1) unstable; urgency=medium

  * Non-maintainer upload
  * Apply upstream patch to fix build with Qt 5.15 (Closes: #975146)

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 08 Dec 2020 11:41:01 +0100

=== debian/control ===
Source: edb-debugger
Section: devel
Priority: optional
Maintainer: Marcio de Souza Oliveira <marciosouza@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libboost-dev,
               libcapstone-dev,
               libdouble-conversion-dev,
               libgraphviz-dev,
               libqt5svg5-dev,
               libqt5xmlpatterns5-dev,
               pkg-config,
               qt5-qmake,
               qtbase5-dev
Standards-Version: 4.5.1
Homepage: https://github.com/eteran/edb-debugger
Vcs-Git: https://salsa.debian.org/debian/edb-debugger.git
Vcs-Browser: https://salsa.debian.org/debian/edb-debugger
Rules-Requires-Root: no

Package: edb-debugger
Architecture: amd64 i386
Depends: edb-debugger-plugins, ${misc:Depends}, ${shlibs:Depends}
Description: cross platform x86/x86-64 debugger
 edb is a graphical cross platform x86/x86-64 debugger.
 It was inspired by Ollydbg, but aims to function on x86
 and x86-64 as well as multiple OS's. Linux is the only
 officially supported platform at the moment, but FreeBSD,
 OpenBSD, OSX and Windows ports are underway with varying
 degrees of functionality.

Package: edb-debugger-plugins
Section: libs
Architecture: amd64 i386
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: edb plugins
 edb is a graphical cross platform x86/x86-64 debugger.
 It was inspired by Ollydbg, but aims to function on x86
 and x86-64 as well as multiple OS's. Linux is the only
 officially supported platform at the moment, but FreeBSD,
 OpenBSD, OSX and Windows ports are underway with varying
 degrees of functionality.
 .
 This package provides the plugins that used by edb.

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #!/usr/bin/make -f
-#export DH_VERBOSE = 1
+#export DH_VERBOSE=1
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic

=== debian/tests/control ===
Test-Command: xvfb-run edb --version
Depends: xauth, xvfb, @
Restrictions: superficial
